## asymptote 2.86+ds

=== LspCpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

if(POLICY CMP0025)
    # detect Apple's Clang
    cmake_policy(SET CMP0025 NEW)
endif()
if(POLICY CMP0054)
    cmake_policy(SET CMP0054 NEW)
endif()

set(LIB_MAJOR_VERSION "1")
set(LIB_MINOR_VERSION "0")
set(LIB_PATCH_VERSION "0")
set(LIB_VERSION_STRING "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_PATCH_VERSION}")

# Without this, paths are not relative in the sources list
cmake_policy(SET CMP0076 NEW)
project(lspcpp VERSION "${LIB_VERSION_STRING}" LANGUAGES CXX C)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
SET(GOOGLETEST_VERSION "0.00")

# compile in RelWithDebInfo  mode by default
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

###########################################################
# Options
###########################################################
function (option_if_not_defined name description default)
    if(NOT DEFINED ${name})
        option(${name} ${description} ${default})
    endif()
endfunction()

option_if_not_defined(USE_SYSTEM_RAPIDJSON "Use system RapidJSON instead of the git submodule if exists" OFF)
option_if_not_defined(LSPCPP_WARNINGS_AS_ERRORS "Treat warnings as errors" OFF)
option_if_not_defined(LSPCPP_BUILD_EXAMPLES "Build example applications" OFF)
option_if_not_defined(LSPCPP_BUILD_FUZZER "Build fuzzer" OFF)
option_if_not_defined(LSPCPP_BUILD_WEBSOCKETS "Build websocket server" ON)
option_if_not_defined(LSPCPP_ASAN "Build lsp with address sanitizer" OFF)
option_if_not_defined(LSPCPP_MSAN "Build lsp with memory sanitizer" OFF)
option_if_not_defined(LSPCPP_TSAN "Build lsp with thread sanitizer" OFF)
option_if_not_defined(LSPCPP_INSTALL "Create lsp install target" OFF)

###########################################################
# Directories
###########################################################
function (set_if_not_defined name value)
    if(NOT DEFINED ${name})
        set(${name} ${value} PARENT_SCOPE)
    endif()
endfunction()

set(LSPCPP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set_if_not_defined(LSPCPP_THIRD_PARTY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/third_party)

macro(lspcpp_set_target_options_with_nuget_pkg target id version)
    if (CMAKE_GENERATOR MATCHES "Visual Studio.*")
        if(EXISTS ${CMAKE_BINARY_DIR}/packages/${id}.${version}/build/${id}.targets)
            target_link_libraries(${target} PRIVATE ${CMAKE_BINARY_DIR}/packages/${id}.${version}/build/${id}.targets)
        elseif(EXISTS ${CMAKE_BINARY_DIR}/packages/${id}.${version}/build/native/${id}.targets)
            target_link_libraries(${target} PRIVATE ${CMAKE_BINARY_DIR}/packages/${id}.${version}/build/native/${id}.targets)
        else()
            message(FATAL_ERROR "Can't find target of ${id}.${version}")
        endif()
    else()
        message(FATAL_ERROR "NUGET package only use in Visual Studio")
    endif()

endmacro()

macro(INSTALL_NUGET id version)
    if (CMAKE_GENERATOR MATCHES "Visual Studio.*")
        unset(nuget_cmd)
        list(APPEND nuget_cmd install ${id} -Prerelease -Version ${version} -OutputDirectory ${CMAKE_BINARY_DIR}/packages)
        message("excute nuget install:${nuget_cmd}")
        execute_process(COMMAND nuget ${nuget_cmd} ENCODING AUTO)
    else()
        message(FATAL_ERROR "INSTALL_NUGET only use in Visual Studio")
    endif()

endmacro()
###########################################################
# Functions
###########################################################
function(lspcpp_set_target_options target)

    set_property(TARGET ${target} PROPERTY CXX_STANDARD_REQUIRED ON)

    # Enable C++14 (Required)
    set_property(TARGET ${target} PROPERTY CXX_STANDARD 14)

    set_property(TARGET ${target} PROPERTY CXX_EXTENSIONS OFF)

    if (CMAKE_GENERATOR MATCHES "Visual Studio.*")
        lspcpp_set_target_options_with_nuget_pkg(${target} boost 1.76.0.0)
        lspcpp_set_target_options_with_nuget_pkg(${target} boost_chrono-vc141 1.76.0.0)
        lspcpp_set_target_options_with_nuget_pkg(${target} boost_date_time-vc141 1.76.0.0)
        lspcpp_set_target_options_with_nuget_pkg(${target} boost_filesystem-vc141 1.76.0.0)
        lspcpp_set_target_options_with_nuget_pkg(${target} boost_program_options-vc141 1.76.0.0)
        lspcpp_set_target_options_with_nuget_pkg(${target} boost_system-vc141 1.76.0.0)
        lspcpp_set_target_options_with_nuget_pkg(${target} boost_thread-vc141 1.76.0.0)
    endif()

    # Enable all warnings
    if(MSVC)
        target_compile_options(${target} PRIVATE "-W4")
    else()
        target_compile_options(${target} PRIVATE "-Wall")
    endif()

    # Disable specific, pedantic warnings
    if(MSVC)
        target_compile_options(${target} PRIVATE
                "-D_CRT_SECURE_NO_WARNINGS"

                # Warnings from nlohmann/json headers.
                "/wd4267" # 'argument': conversion from 'size_t' to 'int', possible loss of data
                "/bigobj" # for visual studio 2022 x64 or later.
                )
    endif()

    # Add define for JSON library in use
    set_target_properties(${target} PROPERTIES
            COMPILE_DEFINITIONS "LSPCPP_JSON_${LSPCPP_JSON_LIBRARY_UPPER}=1"
            )

    # Treat all warnings as errors
    if(LSPCPP_WARNINGS_AS_ERRORS)
        if(MSVC)
            target_compile_options(${target} PRIVATE "/WX")
        else()
            target_compile_options(${target} PRIVATE "-Werror")
        endif()
    endif(LSPCPP_WARNINGS_AS_ERRORS)

    if(LSPCPP_ASAN)
        target_compile_options(${target} PUBLIC "-fsanitize=address")
        target_link_libraries(${target} PUBLIC "-fsanitize=address")
    elseif(LSPCPP_MSAN)
        target_compile_options(${target} PUBLIC "-fsanitize=memory")
        target_link_libraries(${target} PUBLIC "-fsanitize=memory")
    elseif(LSPCPP_TSAN)
        target_compile_options(${target} PUBLIC "-fsanitize=thread")
        target_link_libraries(${target} PUBLIC "-fsanitize=thread")
    endif()

    # Error on undefined symbols
    # if(NOT MSVC)
    #     target_compile_options(${target} PRIVATE "-Wl,--no-undefined")
    # endif()

endfunction()


# Libraries

if (MSVC)
    set(Uri_USE_STATIC_CRT OFF)
endif()
set(Uri_BUILD_TESTS OFF)
add_subdirectory(third_party/uri)

###########################################################
# boost library
###########################################################
if (CMAKE_GENERATOR MATCHES "Visual Studio.*")
    INSTALL_NUGET(boost 1.76.0.0)
    INSTALL_NUGET(boost_chrono-vc141 1.76.0.0)
    INSTALL_NUGET(boost_date_time-vc141 1.76.0.0)
    INSTALL_NUGET(boost_filesystem-vc141 1.76.0.0)
    INSTALL_NUGET(boost_program_options-vc141 1.76.0.0)
    INSTALL_NUGET(boost_system-vc141 1.76.0.0)
    INSTALL_NUGET(boost_thread-vc141 1.76.0.0)
else()

    find_package(Boost COMPONENTS date_time  chrono filesystem system thread program_options)
    if(NOT Boost_FOUND)
        if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
            message(FATAL_ERROR "Can't find boost,lease build boost and install it or install boost with : brew install boost")
        elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
            message(FATAL_ERROR "Can't find boost,please build boost and install it. or install boost with : sudo apt-get install libboost-dev")
        endif()
    endif()
endif()


###########################################################
# JSON library
###########################################################
if(USE_SYSTEM_RAPIDJSON)
    set(RapidJSON_MIN_VERSION "1.1.0")
    find_package(RapidJSON ${RapidJSON_MIN_VERSION} QUIET)
    if(NOT DEFINED RapidJSON_INCLUDE_DIRS AND DEFINED RAPIDJSON_INCLUDE_DIRS)
        set(RapidJSON_INCLUDE_DIRS "${RAPIDJSON_INCLUDE_DIRS}")
    endif()
endif()
if(NOT RapidJSON_FOUND)
    if(EXISTS "${PROJECT_SOURCE_DIR}/third_party/rapidjson/include")
        message(STATUS "Using local RapidJSON")
        set(RapidJSON_INCLUDE_DIRS third_party/rapidjson/include)
    else()
        message(STATUS "Please initialize rapidJSON git submodule as currently installed version is to old:")
        message(STATUS "git submodule init && git submodule update")
        message(FATAL_ERROR "RapidJSON version is likely too old.")
    endif()
endif()


###########################################################
# Targets
###########################################################

# lsp
add_library(lspcpp STATIC)

### Includes
target_include_directories(lspcpp
        PUBLIC
            ${LSPCPP_INCLUDE_DIR}
            ${Boost_INCLUDE_DIRS}
            ${RapidJSON_INCLUDE_DIRS}
            ${Uri_SOURCE_DIR}/include
        )

target_link_libraries(lspcpp PUBLIC network-uri  ${Boost_LIBRARIES})

set(LSPCPP_THIRD_PARTY_DIR_LIST
        ${LSPCPP_THIRD_PARTY_DIR}/utfcpp/source
        )

foreach(include_dir  ${LSPCPP_THIRD_PARTY_DIR_LIST})
    get_filename_component(include_dir_realpath ${include_dir} REALPATH)
    # Don't add as SYSTEM if they are in CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES.
    # It would reorder the system search paths and cause issues with libstdc++'s
    # use of #include_next.
    if(NOT "${include_dir_realpath}" IN_LIST CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES)
        target_include_directories(lspcpp SYSTEM PRIVATE ${include_dir})
    endif()
endforeach()

### Sources
set(JSONRPC_LIST
        src/jsonrpc/Context.cpp
        src/jsonrpc/Endpoint.cpp
        src/jsonrpc/GCThreadContext.cpp
        src/jsonrpc/message.cpp
        src/jsonrpc/MessageJsonHandler.cpp
        src/jsonrpc/RemoteEndPoint.cpp
        src/jsonrpc/serializer.cpp
        src/jsonrpc/StreamMessageProducer.cpp
        src/jsonrpc/TcpServer.cpp
        src/jsonrpc/threaded_queue.cpp
)
set(LSPCPP_LIST
        src/lsp/initialize.cpp
        src/lsp/lsp.cpp
        src/lsp/lsp_diagnostic.cpp
        src/lsp/Markup.cpp
        src/lsp/ParentProcessWatcher.cpp
        src/lsp/ProtocolJsonHandler.cpp
        src/lsp/textDocument.cpp
        src/lsp/utils.cpp
        src/lsp/working_files.cpp
        )

if(LSPCPP_BUILD_WEBSOCKETS)
    set(JSONRPC_LIST
        ${JSONRPC_LIST}
        src/jsonrpc/WebSocketServer.cpp
    )
endif()

target_sources(lspcpp PRIVATE
        ${JSONRPC_LIST}
        ${LSPCPP_LIST})

### Compile options

lspcpp_set_target_options(lspcpp)

set_target_properties(lspcpp PROPERTIES POSITION_INDEPENDENT_CODE 1)

# install
if(LSPCPP_INSTALL)
    include(GNUInstallDirs)

    install(DIRECTORY ${LSPCPP_INCLUDE_DIR}/LibLsp
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
            USE_SOURCE_PERMISSIONS
            )

    install(TARGETS lspcpp
            EXPORT lspcpp-targets
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
            )

    install(EXPORT lspcpp-targets
            FILE lspcpp-config.cmake
            NAMESPACE lspcpp::
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lspcpp
            )
endif()

# examples
if(LSPCPP_BUILD_EXAMPLES)

    ###########################################################
    # OS libraries
    ###########################################################
    if(CMAKE_SYSTEM_NAME MATCHES "Windows")
        set(LSPCPP_OS_LIBS WS2_32)
    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
        set(LSPCPP_OS_LIBS pthread)
    elseif(CMAKE_SYSTEM_NAME MATCHES "Darwin")
        set(LSPCPP_OS_LIBS)
    endif()

    function(build_example target)
        add_executable(${target} "${CMAKE_CURRENT_SOURCE_DIR}/examples/${target}.cpp")
        target_include_directories(${target} PRIVATE ${Uri_SOURCE_DIR}/include)
        set_target_properties(${target} PROPERTIES
                FOLDER "Examples"
                )
        lspcpp_set_target_options(${target})
        target_link_libraries(${target}  PRIVATE lspcpp "${LSPCPP_OS_LIBS}")
    endfunction(build_example)

    set(EXAMPLES

=== LspCpp/third_party/uri/src/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "Unix Makefiles" Generator, CMake Version 3.26

# Default target executed when no arguments are given to make.
default_target: all
.PHONY : default_target

# Allow only one "make -f Makefile2" at a time, but pass parallelism.
.NOTPARALLEL:

#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canonical targets will work.
.SUFFIXES:

# Disable VCS-based implicit rules.
% : %,v

# Disable VCS-based implicit rules.
% : RCS/%

# Disable VCS-based implicit rules.
% : RCS/%,v

# Disable VCS-based implicit rules.
% : SCCS/s.%

# Disable VCS-based implicit rules.
% : s.%

.SUFFIXES: .hpux_make_needs_suffix_list

# Produce verbose output by default.
VERBOSE = 1

# Command-line flag to silence nested $(MAKE).
$(VERBOSE)MAKESILENT = -s

#Suppress display of executed commands.
$(VERBOSE).SILENT:

# A target that is always out of date.
cmake_force:
.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /usr/bin/cmake

# The command to remove a file.
RM = /usr/bin/cmake -E rm -f

# Escaping for special characters.
EQUALS = =

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /usr/local/src/asymptote-2.86/LspCpp

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /usr/local/src/asymptote-2.86/LspCpp

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake cache editor..."
	/usr/bin/ccmake -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache
.PHONY : edit_cache/fast

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	/usr/bin/cmake --regenerate-during-build -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache
.PHONY : rebuild_cache/fast

# Special rule for the target list_install_components
list_install_components:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Available install components are: \"Unspecified\""
.PHONY : list_install_components

# Special rule for the target list_install_components
list_install_components/fast: list_install_components
.PHONY : list_install_components/fast

# Special rule for the target install
install: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install

# Special rule for the target install
install/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install/fast

# Special rule for the target install/local
install/local: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local

# Special rule for the target install/local
install/local/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local/fast

# Special rule for the target install/strip
install/strip: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip

# Special rule for the target install/strip
install/strip/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip/fast

# The main all target
all: cmake_check_build_system
	cd /usr/local/src/asymptote-2.86/LspCpp && $(CMAKE_COMMAND) -E cmake_progress_start /usr/local/src/asymptote-2.86/LspCpp/CMakeFiles /usr/local/src/asymptote-2.86/LspCpp/third_party/uri/src//CMakeFiles/progress.marks
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 third_party/uri/src/all
	$(CMAKE_COMMAND) -E cmake_progress_start /usr/local/src/asymptote-2.86/LspCpp/CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 third_party/uri/src/clean
.PHONY : clean

# The main clean target
clean/fast: clean
.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 third_party/uri/src/preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 third_party/uri/src/preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(CMAKE_COMMAND) -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
.PHONY : depend

# Convenience name for target.
third_party/uri/src/CMakeFiles/network-uri.dir/rule:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 third_party/uri/src/CMakeFiles/network-uri.dir/rule
.PHONY : third_party/uri/src/CMakeFiles/network-uri.dir/rule

# Convenience name for target.
network-uri: third_party/uri/src/CMakeFiles/network-uri.dir/rule
.PHONY : network-uri

# fast build rule for target.
network-uri/fast:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/build
.PHONY : network-uri/fast

detail/uri_advance_parts.o: detail/uri_advance_parts.cpp.o
.PHONY : detail/uri_advance_parts.o

# target to build an object file
detail/uri_advance_parts.cpp.o:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_advance_parts.cpp.o
.PHONY : detail/uri_advance_parts.cpp.o

detail/uri_advance_parts.i: detail/uri_advance_parts.cpp.i
.PHONY : detail/uri_advance_parts.i

# target to preprocess a source file
detail/uri_advance_parts.cpp.i:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_advance_parts.cpp.i
.PHONY : detail/uri_advance_parts.cpp.i

detail/uri_advance_parts.s: detail/uri_advance_parts.cpp.s
.PHONY : detail/uri_advance_parts.s

# target to generate assembly for a file
detail/uri_advance_parts.cpp.s:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_advance_parts.cpp.s
.PHONY : detail/uri_advance_parts.cpp.s

detail/uri_normalize.o: detail/uri_normalize.cpp.o
.PHONY : detail/uri_normalize.o

# target to build an object file
detail/uri_normalize.cpp.o:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_normalize.cpp.o
.PHONY : detail/uri_normalize.cpp.o

detail/uri_normalize.i: detail/uri_normalize.cpp.i
.PHONY : detail/uri_normalize.i

# target to preprocess a source file
detail/uri_normalize.cpp.i:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_normalize.cpp.i
.PHONY : detail/uri_normalize.cpp.i

detail/uri_normalize.s: detail/uri_normalize.cpp.s
.PHONY : detail/uri_normalize.s

# target to generate assembly for a file
detail/uri_normalize.cpp.s:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_normalize.cpp.s
.PHONY : detail/uri_normalize.cpp.s

detail/uri_parse.o: detail/uri_parse.cpp.o
.PHONY : detail/uri_parse.o

# target to build an object file
detail/uri_parse.cpp.o:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_parse.cpp.o
.PHONY : detail/uri_parse.cpp.o

detail/uri_parse.i: detail/uri_parse.cpp.i
.PHONY : detail/uri_parse.i

# target to preprocess a source file
detail/uri_parse.cpp.i:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_parse.cpp.i
.PHONY : detail/uri_parse.cpp.i

detail/uri_parse.s: detail/uri_parse.cpp.s
.PHONY : detail/uri_parse.s

# target to generate assembly for a file
detail/uri_parse.cpp.s:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_parse.cpp.s
.PHONY : detail/uri_parse.cpp.s

detail/uri_parse_authority.o: detail/uri_parse_authority.cpp.o
.PHONY : detail/uri_parse_authority.o

# target to build an object file
detail/uri_parse_authority.cpp.o:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_parse_authority.cpp.o
.PHONY : detail/uri_parse_authority.cpp.o

detail/uri_parse_authority.i: detail/uri_parse_authority.cpp.i
.PHONY : detail/uri_parse_authority.i

# target to preprocess a source file
detail/uri_parse_authority.cpp.i:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_parse_authority.cpp.i
.PHONY : detail/uri_parse_authority.cpp.i

detail/uri_parse_authority.s: detail/uri_parse_authority.cpp.s
.PHONY : detail/uri_parse_authority.s

# target to generate assembly for a file
detail/uri_parse_authority.cpp.s:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_parse_authority.cpp.s
.PHONY : detail/uri_parse_authority.cpp.s

detail/uri_resolve.o: detail/uri_resolve.cpp.o
.PHONY : detail/uri_resolve.o

# target to build an object file
detail/uri_resolve.cpp.o:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_resolve.cpp.o
.PHONY : detail/uri_resolve.cpp.o

detail/uri_resolve.i: detail/uri_resolve.cpp.i
.PHONY : detail/uri_resolve.i

# target to preprocess a source file
detail/uri_resolve.cpp.i:
	cd /usr/local/src/asymptote-2.86/LspCpp && $(MAKE) $(MAKESILENT) -f third_party/uri/src/CMakeFiles/network-uri.dir/build.make third_party/uri/src/CMakeFiles/network-uri.dir/detail/uri_resolve.cpp.i
.PHONY : detail/uri_resolve.cpp.i

detail/uri_resolve.s: detail/uri_resolve.cpp.s
.PHONY : detail/uri_resolve.s

# target to generate assembly for a file
detail/uri_resolve.cpp.s:

=== debian/changelog ===
asymptote (2.86+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Hilmar Preusse <hille42@web.de>  Mon, 12 Jun 2023 00:08:23 +0200

## asymptote 2.86+ds1

=== debian/changelog ===
asymptote (2.86+ds1-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:45:52 +0100

asymptote (2.86+ds1-1) unstable; urgency=medium

  * Remove obsolete patches
  * Mark Debian-specific patches as "Forwarded: not-needed" in metadata.
  * Repack upstreams tar ball another time; remove files, which are
    (re)generated during build. Remove these files in clean target.
    (Closes: #1044090).

 -- Hilmar Preusse <hille42@web.de>  Mon, 11 Sep 2023 00:37:44 +0200

## asymptote 2.87%2Bds

=== GUI/requirements.txt ===
numpy==1.22.0
cson==0.7
PyQt5==5.11
rsvg-convert==2.42.3

=== LspCpp/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,16 @@
 option_if_not_defined(LSPCPP_MSAN "Build lsp with memory sanitizer" OFF)
 option_if_not_defined(LSPCPP_TSAN "Build lsp with thread sanitizer" OFF)
 option_if_not_defined(LSPCPP_INSTALL "Create lsp install target" OFF)
+option_if_not_defined(LSPCPP_SUPPORT_BOEHM_GC
+    "Enable support for Boehm GC. Boehm GC must be available by find_package(BDWgc CONFIG REQUIRED)." OFF)
+option_if_not_defined(LSPCPP_USE_CPP17 "Use C++17 for compilation. Setting this to off requires boost-optional." OFF)
+
+
+# Boehm GC
+
+if (LSPCPP_SUPPORT_BOEHM_GC)
+    find_package(BDWgc CONFIG REQUIRED)
+endif()
 
 ###########################################################
 # Directories
@@ -89,8 +99,12 @@
 
     set_property(TARGET ${target} PROPERTY CXX_STANDARD_REQUIRED ON)
 
-    # Enable C++14 (Required)
-    set_property(TARGET ${target} PROPERTY CXX_STANDARD 14)
+    # Enable C++14/17 (Required)
+    if (LSPCPP_USE_CPP17)
+        set_property(TARGET ${target} PROPERTY CXX_STANDARD 17)
+    else()
+        set_property(TARGET ${target} PROPERTY CXX_STANDARD 14)
+    endif()
 
     set_property(TARGET ${target} PROPERTY CXX_EXTENSIONS OFF)
 
@@ -151,6 +165,11 @@
     # if(NOT MSVC)
     #     target_compile_options(${target} PRIVATE "-Wl,--no-undefined")
     # endif()
+
+    if (LSPCPP_SUPPORT_BOEHM_GC)
+        target_link_libraries(${target} PUBLIC BDWgc::gc)
+        target_compile_definitions(${target} PUBLIC LSPCPP_USEGC)
+    endif()
 
 endfunction()
 
@@ -315,20 +334,3 @@
     ###########################################################
     if(CMAKE_SYSTEM_NAME MATCHES "Windows")
         set(LSPCPP_OS_LIBS WS2_32)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
-        set(LSPCPP_OS_LIBS pthread)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "Darwin")
-        set(LSPCPP_OS_LIBS)
-    endif()
-
-    function(build_example target)
-        add_executable(${target} "${CMAKE_CURRENT_SOURCE_DIR}/examples/${target}.cpp")
-        target_include_directories(${target} PRIVATE ${Uri_SOURCE_DIR}/include)
-        set_target_properties(${target} PROPERTIES
-                FOLDER "Examples"
-                )
-        lspcpp_set_target_options(${target})
-        target_link_libraries(${target}  PRIVATE lspcpp "${LSPCPP_OS_LIBS}")
-    endfunction(build_example)
-
-    set(EXAMPLES

## asymptote 2.87+ds

=== cudareflect/tinyexr/examples/deepview/Makefile ===
all:
	g++ -I ../../deps/miniz -o deepview -g -O2 main.cc trackball.cc ../../tinyexr.cc ../../deps/miniz/miniz.c -framework OpenGL -framework GLUT

=== debian/changelog ===
asymptote (2.87+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:24:44 +1100

asymptote (2.87+ds-1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:41:25 +0000

asymptote (2.87+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
  * Replace freeglut3-dev by libglut-dev in control file of test suite.
  * Remove libboost-dev from control file of test suite.
  * Run test suite during build (Closes: #1061151).
  * Add libtirpc-dev to build depends of asymptote and test suite
    (Closes: #1065212).

 -- Hilmar Preusse <hille42@web.de>  Sat, 02 Mar 2024 23:29:20 +0100

=== debian/control ===
Source: asymptote
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>,
           Ruben Molina <rmolina@udea.edu.co>,
           Picca Frédéric-Emmanuel <picca@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Hilmar Preusse <hille42@web.de>
Section: tex
Priority: optional
Build-Depends: bison,
               debhelper-compat (= 13),
               dh-python,
               flex,
               cmake,
               pkg-config,
               libglut-dev,
               libosmesa6-dev,
               ghostscript,
               imagemagick,
               libboost-program-options-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libcurl4-gnutls-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgc-dev,
               libgsl-dev,
               libncurses-dev,
               libreadline-dev,
               libsigsegv-dev,
               libtimedate-perl,
	       libtirpc-dev,
               python3,
               pyqt5-dev-tools,
               rapidjson-dev,
               tex-common,
               doxygen,
               graphviz,
               texinfo,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-latex-recommended,
               texlive-fonts-recommended,
               texlive-pstricks,
               zlib1g-dev,
               libglm-dev,
               libglew-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://asymptote.sourceforge.net/
Vcs-Git: https://github.com/debian-tex/asymptote.git
Vcs-Browser: https://github.com/debian-tex/asymptote

Package: asymptote
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         ghostscript,
         imagemagick,
         texlive-binaries,
         texlive-latex-base,
         texlive-pstricks,
         texlive-plain-generic,
         xdg-utils
Suggests: asymptote-x11
Recommends: asymptote-doc
Description: script-based vector graphics language inspired by MetaPost
 Asymptote is a powerful script-based vector graphics language for technical
 drawings, inspired by MetaPost but with an improved C++-like syntax.
 Asymptote provides for figures the same high-quality level of typesetting that
 LaTeX does for scientific text.

Package: asymptote-x11
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         asymptote (>= ${binary:Version}),
         librsvg2-bin,
         python3-cson,
         python3-numpy,
         python3-pyqt5,
         python3-pyqt5.qtsvg
Suggests: gv,
          evince | pdf-viewer
Breaks: asymptote (<= 2.49-2)
Replaces: asymptote (<= 2.49-2)
Description: script-based vector graphics language inspired by MetaPost - the GUI part
 Asymptote is a powerful script-based vector graphics language for technical
 drawings, inspired by MetaPost but with an improved C++-like syntax.
 Asymptote provides for figures the same high-quality level of typesetting that
 LaTeX does for scientific text.
 .
 In the event that adjustments to the final figure are required, the
 preliminary Graphical User Interface (GUI) xasy included with Asymptote allows
 you to move graphical objects and draw new ones. The modified figure can then
 be saved as a normal Asymptote file.

Package: asymptote-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Recommends: asymptote,
            info-browser | pdf-viewer | www-browser
Description: documentation and examples for asymptote
 Asymptote is a powerful descriptive vector graphics language that
 provides a natural coordinate-based framework for technical drawing.
 This package provides documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

# Avoid unneeded library dependencies reported by dpkg-shlibdeps.
DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

#ifeq ($(DEB_HOST_ARCH), hurd-i386)
#  LSPSERVER=--disable-lsp
#endif

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- --enable-gc=system	\
		--with-latex=/usr/share/texmf/tex/latex	\
		--with-context=/usr/share/texmf/tex/context/third $(LSPSERVER)\
		$(foreach v,CFLAGS CPPFLAGS CXXFLAGS LDFLAGS,'$(v)=$($(v))')

# Avoid a warning every time asy is run if HOME is unset.
export ASYMPTOTE_HOME := $(CURDIR)/debian/tmp_asymptote_home
override_dh_auto_configure: | $(ASYMPTOTE_HOME)
$(ASYMPTOTE_HOME):
	mkdir $(ASYMPTOTE_HOME)

override_dh_auto_build:
	make -j4 asy
	make man
	make all html
	# fix location of images in info document
	sed -e 's!image src="\([^"]*\)"!image src="/usr/share/doc/asymptote/html/\1"!g' < doc/png/asymptote.info > doc/png/asymptote.info.fixed
	mv doc/png/asymptote.info.fixed doc/png/asymptote.info

override_dh_auto_install:
	make install-asy DESTDIR=$(CURDIR)/debian/tmp
	# fix xasy absolute link
	ln -sf ../share/asymptote/GUI/xasy.py debian/tmp/usr/bin/xasy
	# fix permissions
	chmod 0644 debian/tmp/usr/share/asymptote/shaders/*.glsl
	chmod 0644 debian/tmp/usr/share/asymptote/GUI/icons_rc.py
	dh_installtex -pasymptote

#override_dh_auto_test:
#	: do nothing here, otherwise make tries to compile prc/test.cc

override_dh_compress:
	dh_compress -X.pdf

override_dh_clean:
	dh_clean
	rm --force doc/*.aux doc/*.cp doc/*.cps doc/*.idx doc/*.ins doc/*.log doc/*.toc
	rm -fr $(ASYMPTOTE_HOME)

=== debian/tests/control ===
Tests: test-suite
Depends: bison,
	dh-python,
	dpkg-dev (>= 1.16.1),
	build-essential,
	doxygen,
	graphviz,
	flex,
	cmake,
	pkg-config,
	libglut-dev,
	libosmesa6-dev,
	ghostscript,
	imagemagick,
	libeigen3-dev,
	libfftw3-dev,
	libgc-dev,
	libgsl-dev,
	libncurses-dev,
	libreadline-dev,
	libsigsegv-dev,
	libtimedate-perl,
	libtirpc-dev,
	python3,
	pyqt5-dev-tools,
	zlib1g-dev,
	libboost-program-options-dev,
	libboost-filesystem-dev,
	libboost-thread-dev,
	libcurl4-gnutls-dev,
	libglm-dev,
	libglew-dev,
	texlive-latex-base
Restrictions: build-needed, allow-stderr

## asymptote 2.89+ds

=== debian/changelog ===
asymptote (2.89+ds-1ubuntu1) oracular; urgency=medium

  * Fix autopkgtest following dpkg changes (LP: #2071468)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 29 Jun 2024 20:29:47 -0400

asymptote (2.89+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
  * Lintian:
    - W: build-depends-on-obsolete-package
    - W: superfluous-file-pattern
  * Bump Standards version, no changes needed.

 -- Hilmar Preusse <hille42@web.de>  Sat, 27 Apr 2024 10:07:57 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-python,
                flex,
                cmake,
-               pkg-config,
+               pkgconf,
                libglut-dev,
                libosmesa6-dev,
                ghostscript,
@@ -46,7 +46,7 @@
                zlib1g-dev,
                libglm-dev,
                libglew-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://asymptote.sourceforge.net/
 Vcs-Git: https://github.com/debian-tex/asymptote.git

=== debian/tests/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	graphviz,
 	flex,
 	cmake,
-	pkg-config,
+	pkgconf,
 	libglut-dev,
 	libosmesa6-dev,
 	ghostscript,

## asymptote 2.90+ds

=== debian/changelog ===
asymptote (2.90+ds-1build1) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 08:15:12 +0200

asymptote (2.90+ds-1) unstable; urgency=medium

  * New upstream version, refresh patches.

  * Test installed asy package instead of rebuilding it in autopkg
    test suite. Thanks to Sven Joachim for the bug report and idea
    how to implement (Closes: #1061152).

  [ Jeremy Bícha ]
  * Fix autopkgtest following dpkg changes (LP: #2071468)

 -- Hilmar Preuße <hille42@debian.org>  Sun, 21 Jul 2024 12:08:06 +0200

## asymptote 2.91+ds

=== debian/changelog ===
asymptote (2.91+ds-1) unstable; urgency=medium

  * New upstream version, refresh patches.
  * Fix d/copyright a little bit thanks to licenserecon.

 -- Hilmar Preuße <hille42@debian.org>  Wed, 04 Sep 2024 23:49:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: asymptote
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
+Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>,
            Ruben Molina <rmolina@udea.edu.co>,
            Picca Frédéric-Emmanuel <picca@debian.org>,
            Norbert Preining <norbert@preining.info>,
-           Hilmar Preusse <hille42@web.de>
+           Hilmar Preuße <hille42@debian.org>
 Section: tex
 Priority: optional
 Build-Depends: bison,

## asymptote 2.92+ds

=== debian/changelog ===
asymptote (2.92+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
  * Lintian:
      W: asymptote source: missing-license-paragraph-in-dep5-copyright
      W: asymptote source: space-in-std-shortname-in-dep5-copyright

 -- Hilmar Preuße <hille42@debian.org>  Sat, 12 Oct 2024 00:12:41 +0200

## asymptote 2.95%2Bds

=== cxxtests/CMakeLists.txt ===
if (NOT ENABLE_ASY_CXXTEST)
    message(FATAL_ERROR "cxxtests require asy-cxxtest enabled")
endif()

set(TEST_CXX_SRC_ROOT ${CMAKE_CURRENT_LIST_DIR})

include(${TEST_CXX_SRC_ROOT}/cmake-scripts/external-libs.cmake)
include(${TEST_CXX_SRC_ROOT}/cmake-scripts/tests.cmake)

# test target

add_executable(asyCxxTests ${ASY_TEST_SOURCES} ${TEST_CXX_SRC_ROOT}/src/testMain.cc)
target_include_directories(
        asyCxxTests
        PRIVATE ${TEST_CXX_SRC_ROOT}/include
)
target_link_libraries(asyCxxTests
        PRIVATE asycore GTest::gtest GTest::gmock)

include(GoogleTest)
gtest_discover_tests(asyCxxTests TEST_PREFIX cxxtests.)

## asymptote 2.95+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.27)

include(cmake-scripts/common.cmake)
include(asy-pkg-version-suffix.cmake OPTIONAL RESULT_VARIABLE ASY_ADDR_VERSION_SUFFIX_FILE)
include(cmake-scripts/options.cmake)
include(pkg-info.cmake)
include(cmake-scripts/vcpkg-features.cmake)

project(${ASY_PACKAGE_NAME})

include(cmake-scripts/compiler-config.cmake)
include(cmake-scripts/basic-parameters.cmake)
include(cmake-scripts/buildfiles-to-src.cmake)
include(cmake-scripts/asy-files.cmake)

# setting build files
if (WIN32)
    include(cmake-scripts/win32-specific.cmake)
endif()

build_files_to_src(CORE_BUILD_FILES CORE_SOURCE_FILES)
include(cmake-scripts/external-libs.cmake)
include(cmake-scripts/thirdparty-impl.cmake)
include(cmake-scripts/backport-libs.cmake)

# PRC
add_subdirectory(prc/)
list(APPEND ASY_STATIC_LIBARIES PRC)

get_target_property(prc_incl_dir PRC INCLUDE_DIRECTORIES)
list(APPEND ASYMPTOTE_INCLUDES $<TARGET_PROPERTY:PRC,INCLUDE_DIRECTORIES>)

include(cmake-scripts/gnu-install-macros.cmake)
include(cmake-scripts/asy-macro.cmake)

include(cmake-scripts/generated-files.cmake)

# asy-reflect
if (ENABLE_CUDA_ASY_REFLECT)
    message(STATUS "asy reflect target enabled")
    add_subdirectory(cudareflect/)
endif()

# defining asy target

add_library(
        asycore STATIC
        ${CORE_SOURCE_FILES}
        ${ASY_GENERATED_BUILD_SOURCES}
)

target_include_directories(asycore PUBLIC ${ASYMPTOTE_INCLUDES})
add_dependencies(asycore asy_gen_headers)
target_link_libraries(asycore PUBLIC ${ASY_STATIC_LIBARIES})
target_compile_definitions(asycore PUBLIC ${ASY_MACROS})
target_compile_options(asycore PUBLIC ${ASY_COMPILE_OPTS})

# asy executable

add_executable(
        asy ${ASY_SRC_DIR}/main.cc ${ASY_WIN_RC_FILE}
)

target_link_libraries(asy PUBLIC asycore)

# base files
include(cmake-scripts/asy-base-files.cmake)

# asy + base files
add_custom_target(asy-basefiles DEPENDS ${ASY_OUTPUT_BASE_FILES})
add_custom_target(asy-with-basefiles ALL DEPENDS asy asy-basefiles)

# documentation generation

if (ENABLE_DOCGEN)
    include(cmake-scripts/docgen.cmake)
endif()

# testing

enable_testing()
include(cmake-scripts/tests-asy.cmake)
include(cmake-scripts/tests-wce.cmake)

if (ENABLE_ASY_CXXTEST)
    add_subdirectory(cxxtests)
endif()


# installation (on windows, pre-NSIS)
if (WIN32)
    include(cmake-scripts/win32-pre-nsis-installer.cmake)
endif()

=== LspCpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.8)
+cmake_minimum_required(VERSION 3.16)
 
 if(POLICY CMP0025)
     # detect Apple's Clang
@@ -43,15 +43,32 @@
 option_if_not_defined(LSPCPP_MSAN "Build lsp with memory sanitizer" OFF)
 option_if_not_defined(LSPCPP_TSAN "Build lsp with thread sanitizer" OFF)
 option_if_not_defined(LSPCPP_INSTALL "Create lsp install target" OFF)
-option_if_not_defined(LSPCPP_SUPPORT_BOEHM_GC
-    "Enable support for Boehm GC. Boehm GC must be available by find_package(BDWgc CONFIG REQUIRED)." OFF)
+option_if_not_defined(LSPCPP_SUPPORT_BOEHM_GC "\
+Enable support for Boehm GC. GC must be specified LSPCPP_GC_DOWNLOADED_ROOT, if downloaded or by
+find_package(BDWgc CONFIG REQUIRED) or pkg_config." OFF)
 option_if_not_defined(LSPCPP_USE_CPP17 "Use C++17 for compilation. Setting this to off requires boost-optional." OFF)
 
-
+set(LSPCPP_GC_DOWNLOADED_ROOT "" CACHE STRING "\
+If using downloaded gc root from https://www.hboehm.info/gc/, extract its contents and set this setting to
+where the tar.gz file is extracted to. This directory must be an absolute path.
+If this setting is set, LspCpp will use downloaded GC regardless of whether GC from find_package or
+pkg_config is available or not.
+")
+
+###########################################################
 # Boehm GC
-
-if (LSPCPP_SUPPORT_BOEHM_GC)
-    find_package(BDWgc CONFIG REQUIRED)
+###########################################################
+
+if (LSPCPP_SUPPORT_BOEHM_GC AND NOT LSPCPP_GC_DOWNLOADED_ROOT)
+    message(STATUS "Attempting to find BDWgc by find_package")
+    find_package(BDWgc CONFIG)
+    if (NOT BDWgc_FOUND)
+        set(GC_USE_PKGCONFIG 1)
+        # fallback to pkg-config
+        message(STATUS "CMake config for BDWgc not found; falling back to pkg-config")
+        find_package(PkgConfig REQUIRED)
+        pkg_check_modules(gc REQUIRED IMPORTED_TARGET bdw-gc)
+    endif()
 endif()
 
 ###########################################################
@@ -167,7 +184,27 @@
     # endif()
 
     if (LSPCPP_SUPPORT_BOEHM_GC)
-        target_link_libraries(${target} PUBLIC BDWgc::gc)
+        if (LSPCPP_GC_DOWNLOADED_ROOT)
+            message(STATUS "Using manually downloaded GC")
+            target_include_directories(${target} PUBLIC ${LSPCPP_GC_DOWNLOADED_ROOT}/include)
+        else()
+            if (NOT GC_USE_PKGCONFIG)
+                message(STATUS "Using cmake config for locating gc")
+                target_link_libraries(${target} PUBLIC BDWgc::gc)
+                get_target_property(GC_INCLUDE_DIRS_BASE BDWgc::gc INTERFACE_INCLUDE_DIRECTORIES)
+            else()
+                message(STATUS "Using pkg-config for locating gc")
+                target_link_libraries(${target} PUBLIC PkgConfig::gc)
+                get_target_property(GC_INCLUDE_DIRS_BASE PkgConfig::gc INTERFACE_INCLUDE_DIRECTORIES)
+            endif()
+
+            if (NOT GC_INCLUDE_DIRS_BASE STREQUAL "GC_INCLUDE_DIRS_BASE-NOTFOUND")
+                list(TRANSFORM GC_INCLUDE_DIRS_BASE APPEND /gc)
+                target_include_directories(${target} PUBLIC ${GC_INCLUDE_DIRS_BASE})
+            else()
+                message(WARNING "Cannot find GC include directories; compilation may not work")
+            endif()
+        endif()
         target_compile_definitions(${target} PUBLIC LSPCPP_USEGC)
     endif()
 
@@ -261,76 +298,3 @@
 endforeach()
 
 ### Sources
-set(JSONRPC_LIST
-        src/jsonrpc/Context.cpp
-        src/jsonrpc/Endpoint.cpp
-        src/jsonrpc/GCThreadContext.cpp
-        src/jsonrpc/message.cpp
-        src/jsonrpc/MessageJsonHandler.cpp
-        src/jsonrpc/RemoteEndPoint.cpp
-        src/jsonrpc/serializer.cpp
-        src/jsonrpc/StreamMessageProducer.cpp
-        src/jsonrpc/TcpServer.cpp
-        src/jsonrpc/threaded_queue.cpp
-)
-set(LSPCPP_LIST
-        src/lsp/initialize.cpp
-        src/lsp/lsp.cpp
-        src/lsp/lsp_diagnostic.cpp
-        src/lsp/Markup.cpp
-        src/lsp/ParentProcessWatcher.cpp
-        src/lsp/ProtocolJsonHandler.cpp
-        src/lsp/textDocument.cpp
-        src/lsp/utils.cpp
-        src/lsp/working_files.cpp
-        )
-
-if(LSPCPP_BUILD_WEBSOCKETS)
-    set(JSONRPC_LIST
-        ${JSONRPC_LIST}
-        src/jsonrpc/WebSocketServer.cpp
-    )
-endif()
-
-target_sources(lspcpp PRIVATE
-        ${JSONRPC_LIST}
-        ${LSPCPP_LIST})
-
-### Compile options
-
-lspcpp_set_target_options(lspcpp)
-
-set_target_properties(lspcpp PROPERTIES POSITION_INDEPENDENT_CODE 1)
-
-# install
-if(LSPCPP_INSTALL)
-    include(GNUInstallDirs)
-
-    install(DIRECTORY ${LSPCPP_INCLUDE_DIR}/LibLsp
-            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-            USE_SOURCE_PERMISSIONS
-            )
-
-    install(TARGETS lspcpp
-            EXPORT lspcpp-targets
-            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-            INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
-            )
-
-    install(EXPORT lspcpp-targets
-            FILE lspcpp-config.cmake
-            NAMESPACE lspcpp::
-            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lspcpp
-            )
-endif()
-
-# examples
-if(LSPCPP_BUILD_EXAMPLES)
-
-    ###########################################################
-    # OS libraries
-    ###########################################################
-    if(CMAKE_SYSTEM_NAME MATCHES "Windows")
-        set(LSPCPP_OS_LIBS WS2_32)

=== tinyexr/jni/Makefile ===
ifeq ($(ANDROID_HOME),)
NDK ?= $(ANDROID_NDK)
else
NDK ?= $(lastword $(sort $(wildcard $(dir $(ANDROID_HOME))/android-ndk*)))
endif

all:
	$(NDK)/ndk-build V=1

=== debian/changelog ===
asymptote (2.95+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
    - d/copyright: upstream restructured repo, update exclude pattern.

 -- Hilmar Preuße <hille42@debian.org>  Sat, 30 Nov 2024 00:12:57 +0100

=== debian/control ===
--- 
+++ 
@@ -31,6 +31,7 @@
                libtimedate-perl,
 	       libtirpc-dev,
                python3,
+               python3-click,
                pyqt5-dev-tools,
                rapidjson-dev,
                tex-common,

=== debian/rules ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	ln -sf ../share/asymptote/GUI/xasy.py debian/tmp/usr/bin/xasy
 	# fix permissions
 	chmod 0644 debian/tmp/usr/share/asymptote/shaders/*.glsl
-	chmod 0644 debian/tmp/usr/share/asymptote/GUI/icons_rc.py
+	#chmod 0644 debian/tmp/usr/share/asymptote/GUI/icons_rc.py
 	dh_installtex -pasymptote
 
 #override_dh_auto_test:

=== debian/tests/control ===
Tests: test-suite
Depends: asymptote
Restrictions: allow-stderr
